unit Unit1;

interface

uses
  Windows, Messages,SysUtils,
  Variants, Classes, Graphics,
  Controls, Forms, Dialogs,
  ComCtrls, Menus, ExtCtrls,
  StdCtrls, Ucomunes, math;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    Image1: TImage;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
    fig   : CFigura;
    papel : Tcanvas;
    NPY   : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// create de la Forma
procedure TForm1.FormCreate(Sender: TObject);
begin
  papel := Image1.Canvas;
  NPY   := Image1.Height;
end;


// Metodo abrir Arcbhivo de figura
procedure TForm1.Button1Click(Sender: TObject);
var
  k  : word;
  id : TextFile;
  nn : string;
begin
  // asignando el nombre en disco al manejado
  AssignFile(id,'./bib1/fig1.sut');
  // abrir para lectura
  reset(id);

  // manipularlo
  readln(id,nn);
  Memo1.Lines.Add(nn);

  // leer puntos
  Memo1.Lines.Add('');
  readln(id,fig.np);
  Memo1.Lines.Add('NP= '+IntToStr(fig.np));

  Setlength(fig.Apun,fig.np,2);
  for k := 0 to fig.np - 1 do begin
    readln(id,fig.Apun[k][0], fig.Apun[k][1]);
    Memo1.Lines.Add(
         FloatToStr(fig.Apun[k][0])+ ' '+
         FloatToStr(fig.Apun[k][1]));
  end;

  // leer trazos
  Memo1.Lines.Add('');
  readln(id,fig.nt);
  Memo1.Lines.Add('NT= '+IntToStr(fig.nt));

  Setlength(fig.Atra,fig.nt,2);
  for k := 0 to fig.nt - 1 do begin
    readln(id,fig.Atra[k][0], fig.Atra[k][1]);
    Memo1.Lines.Add(
         IntToStr(fig.Atra[k][0])+ ' '+
         IntToStr(fig.Atra[k][1]));
  end;

  // leer un renglon y omitir su contenido
  readln(id);

  // PC escala
  Memo1.Lines.Add('');
    readln(id,fig.PCEx , fig.PCEy);
    Memo1.Lines.Add(
         FloatToStr(fig.PCEx)+ ' '+
         FloatToStr(fig.PCEy));

  // PC rotacion
  Memo1.Lines.Add('');
    readln(id,fig.PCRx, fig.PCRy);
    Memo1.Lines.Add(
         FloatToStr(fig.PCRx)+ ' '+
         FloatToStr(fig.PCRy));

  // cerrar archivo
  CloseFile(id);
end;


// ------ del escenario

// refrescar escenario
procedure TForm1.Button4Click(Sender: TObject);
var
  p,q,k, ff, XX, YY : integer;
begin
// recorer trazos
  ff := 20;
  XX := 50;
  YY := 50;

  for k := 0 to fig.nt - 1 do begin
    p := fig.Atra[k][0];
    q := fig.Atra[k][1];

    papel.MoveTo(XX + ceil(ff*fig.Apun[p][0]),
                 NPY-(YY + ceil(ff*fig.Apun[p][1])));

    papel.LineTo(XX + ceil(ff*fig.Apun[q][0]),
                 NPY-(YY + ceil(ff*fig.Apun[q][1])));



  end;
end;


end.
